Index: pjproject/branches/projects/uwp/build.mak.in
===================================================================
--- pjproject/branches/projects/uwp/build.mak.in	(revision 5512)
+++ pjproject/branches/projects/uwp/build.mak.in	(revision 5513)
@@ -122,4 +122,33 @@
 endif
 
+ifneq (@ac_no_yuv@,1)
+ifeq (@ac_external_yuv@,1)
+APP_THIRD_PARTY_EXT += -lyuv
+else
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libyuv-$(LIB_SUFFIX)
+ifeq ($(PJ_SHARED_LIBRARIES),)
+APP_THIRD_PARTY_LIBS += -lyuv-$(TARGET_NAME)
+else
+APP_THIRD_PARTY_LIBS += -lyuv
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libyuv.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libyuv.$(SHLIB_SUFFIX)
+endif
+endif
+endif
+
+ifneq (@ac_no_webrtc@,1)
+ifeq (@ac_external_webrtc@,1)
+APP_THIRD_PARTY_EXT += -lwebrtc
+else
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libwebrtc-$(LIB_SUFFIX)
+ifeq ($(PJ_SHARED_LIBRARIES),)
+APP_THIRD_PARTY_LIBS += -lwebrtc-$(TARGET_NAME)
+else
+APP_THIRD_PARTY_LIBS += -lwebrtc
+APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libwebrtc.$(SHLIB_SUFFIX).$(PJ_VERSION_MAJOR) $(PJ_DIR)/third_party/lib/libwebrtc.$(SHLIB_SUFFIX)
+endif
+endif
+endif
+
+
 # Additional flags
 @ac_build_mak_vars@
@@ -148,21 +177,19 @@
 # QT
 AC_PJMEDIA_VIDEO_HAS_QT = @ac_pjmedia_video_has_qt@
-QT_CFLAGS = @ac_qt_cflags@
-
-# iOS
-IOS_CFLAGS = @ac_ios_cflags@
+# QT_CFLAGS = @ac_qt_cflags@
+
+# Darwin (Mac and iOS)
+AC_PJMEDIA_VIDEO_HAS_DARWIN = @ac_pjmedia_video_has_darwin@
+AC_PJMEDIA_VIDEO_HAS_IOS_OPENGL = @ac_pjmedia_video_has_ios_opengl@
+DARWIN_CFLAGS = @ac_darwin_cflags@
 
 # Android
 ANDROID_CFLAGS = @ac_android_cflags@
 
-# libyuv
-LIBYUV_CFLAGS = @ac_libyuv_cflags@ 
-LIBYUV_LDFLAGS =  @ac_libyuv_ldflags@
-
 # PJMEDIA features exclusion
 PJ_VIDEO_CFLAGS += $(SDL_CFLAGS) $(FFMPEG_CFLAGS) $(V4L2_CFLAGS) $(QT_CFLAGS) \
-		   $(OPENH264_CFLAGS) $(IOS_CFLAGS) $(LIBYUV_CFLAGS)
+		   $(OPENH264_CFLAGS) $(DARWIN_CFLAGS)
 PJ_VIDEO_LDFLAGS += $(SDL_LDFLAGS) $(FFMPEG_LDFLAGS) $(V4L2_LDFLAGS) \
-                   $(OPENH264_LDFLAGS) $(LIBYUV_LDFLAGS)
+                   $(OPENH264_LDFLAGS)
 
 # CFLAGS, LDFLAGS, and LIBS to be used by applications
Index: pjproject/branches/projects/uwp/build/rules.mak
===================================================================
--- pjproject/branches/projects/uwp/build/rules.mak	(revision 5512)
+++ pjproject/branches/projects/uwp/build/rules.mak	(revision 5513)
@@ -52,5 +52,5 @@
 # FULL_SRCS is ../src/app/file1.c ../src/app/file1.S
 #
-FULL_SRCS = $(foreach file, $($(APP)_OBJS), $(SRCDIR)/$(basename $(file)).m $(SRCDIR)/$(basename $(file)).c $(SRCDIR)/$(basename $(file)).cpp $(SRCDIR)/$(basename $(file)).S)
+FULL_SRCS = $(foreach file, $($(APP)_OBJS), $(SRCDIR)/$(basename $(file)).m $(SRCDIR)/$(basename $(file)).c $(SRCDIR)/$(basename $(file)).cpp $(SRCDIR)/$(basename $(file)).cc $(SRCDIR)/$(basename $(file)).S)
 
 #
@@ -171,4 +171,9 @@
 
 $(OBJDIR)/%$(OBJEXT): $(SRCDIR)/%.cpp
+	$(CXX) $($(APP)_CXXFLAGS) \
+		$(CC_OUT)$(subst /,$(HOST_PSEP),$@) \
+		$(subst /,$(HOST_PSEP),$<)
+
+$(OBJDIR)/%$(OBJEXT): $(SRCDIR)/%.cc
 	$(CXX) $($(APP)_CXXFLAGS) \
 		$(CC_OUT)$(subst /,$(HOST_PSEP),$@) \
Index: pjproject/branches/projects/uwp/configure-android
===================================================================
--- pjproject/branches/projects/uwp/configure-android	(revision 5512)
+++ pjproject/branches/projects/uwp/configure-android	(revision 5513)
@@ -62,6 +62,12 @@
     IGNORE_CFLAGS="\-M\|\-f*stack\|\-f*alias"
   fi
-
-  NDK_OUT=`${ANDROID_NDK_ROOT}/ndk-build -n -C ${ANDROID_NDK_ROOT}/samples/hello-jni NDK_TOOLCHAIN_VERSION=4.8 APP_PLATFORM=${APP_PLATFORM} APP_ABI=${TARGET_ABI}`
+  
+  if test -f ${ANDROID_NDK_ROOT}/build/ndk-build; then    
+    NDK_BUILD=${ANDROID_NDK_ROOT}/build/ndk-build
+  else 
+    NDK_BUILD=${ANDROID_NDK_ROOT}/ndk-build
+  fi
+
+  NDK_OUT=`${NDK_BUILD} -n -C pjsip-apps/src/samples/android_sample APP_PLATFORM=${APP_PLATFORM} APP_ABI=${TARGET_ABI}`
   if test ! "${NDK_OUT}"; then
     echo "$F error: failed to run ndk-build, check ANDROID_NDK_ROOT env var"
@@ -73,5 +79,5 @@
 
     # Parse NDK CXXFLAGS
-    if test "x${NDK_CXX}" != "x" -a "x`echo $i|grep 'hello-jni'`" = "x"; then
+    if test "x${NDK_CXX}" != "x" -a "x`echo $i|grep 'dummy'`" = "x"; then
       if test "x`echo $i|grep '\-\-sysroot='`" != "x"; then
         ANDROID_SYSROOT=`echo $i|sed 's/--sysroot=//'`;
@@ -81,5 +87,5 @@
 
     # Parse NDK CFLAGS
-    if test "x${NDK_CC}" != "x" -a "x`echo $i|grep 'hello-jni'`" = "x" -a "${ADD_CFLAGS}" = "1"; then
+    if test "x${NDK_CC}" != "x" -a "x`echo $i|grep 'dummy'`" = "x" -a "${ADD_CFLAGS}" = "1"; then
       if test "$i" = "-c"; then ADD_CFLAGS="0"; else
         if test "x`echo $i|grep ${IGNORE_CFLAGS}`" = "x"; then
@@ -108,7 +114,8 @@
   if test "x`echo ${TARGET_HOST} | grep 'linux-android'`" = "x"; then
     #TARGET_HOST=`echo ${TARGET_HOST} | sed -e 's/\(.*\)\-\([0-9\.]*\)/\1-linux-android-\2/'`
-    TARGET_HOST+=-linux-android
-  fi
-
+    TARGET_HOST="${TARGET_HOST}-linux-android"
+  fi
+
+  export TARGET_ABI="${TARGET_ABI}"
   export CC="${NDK_CC}"
   export CXX="${NDK_CXX}"
@@ -116,5 +123,5 @@
   export RANLIB=`echo ${NDK_CXX}|sed 's/-g++/-ranlib/'`;
 
-  export LDFLAGS="${LDFLAGS} -nostdlib -L${ANDROID_SYSROOT}${USR_LIB}"
+  export LDFLAGS="${LDFLAGS} --sysroot=${ANDROID_SYSROOT}"
   export LIBS="${LIBS} -lc -lgcc -ldl"
   export CFLAGS="${NDK_CFLAGS} ${CFLAGS}"
@@ -144,4 +151,5 @@
   fi
 
+  export TARGET_ABI="${TARGET_ABI}"
   export CC="${ANDROID_TC}/bin/${TARGET_HOST}-gcc"
   export CXX="${ANDROID_TC}/bin/${TARGET_HOST}-g++"
@@ -149,7 +157,7 @@
   export RANLIB="${ANDROID_TC}/bin/${TARGET_HOST}-ranlib"
 
-  export LDFLAGS="${LDFLAGS} -nostdlib -L${ANDROID_SYSROOT}${USR_LIB}"
+  export LDFLAGS="${LDFLAGS} --sysroot=${ANDROID_SYSROOT}"
   export LIBS="${LIBS} -lc -lgcc"
-  export CFLAGS="${CFLAGS} -I${ANDROID_SYSROOT}/usr/include"
+  export CFLAGS="${CFLAGS} --sysroot=${ANDROID_SYSROOT}"
   export CPPFLAGS="${CFLAGS} -fexceptions -frtti"
   export CXXFLAGS="${CXXFLAGS} -shared --sysroot=${ANDROID_SYSROOT} -fexceptions -frtti"
@@ -168,10 +176,10 @@
 STDCPP_TC_VER=`ls -d ${ANDROID_NDK_ROOT}/sources/cxx-stl/gnu-libstdc++/[0-9]* | sort -gr | head -1`
 STDCPP_CFLAGS="-I${STDCPP_TC_VER}/include -I${STDCPP_TC_VER}/libs/${TARGET_ABI}/include"
-STDCPP_LIBS="${ANDROID_SYSROOT}${USR_LIB}/crtbegin_so.o -lgnustl_static"
+STDCPP_LIBS="-lgnustl_static"
 STDCPP_LDFLAGS="-L${STDCPP_TC_VER}/libs/${TARGET_ABI}/"
 
 # stlport
 #STDCPP_CFLAGS="-I${ANDROID_NDK_ROOT}/sources/cxx-stl/stlport/stlport"
-#STDCPP_LIBS="${ANDROID_SYSROOT}${USR_LIB}/crtbegin_so.o -lstlport_static -ldl"
+#STDCPP_LIBS="-lstlport_static -ldl"
 #STDCPP_LDFLAGS="-L${ANDROID_NDK_ROOT}/sources/cxx-stl/stlport/libs/${TARGET_ABI}"
 
@@ -192,4 +200,5 @@
   echo " RANLIB = ${RANLIB}"
   echo " TARGET_HOST = ${TARGET_HOST}"
+  echo " TARGET_ABI = ${TARGET_ABI}"
 fi
 
Index: pjproject/branches/projects/uwp/configure-iphone
===================================================================
--- pjproject/branches/projects/uwp/configure-iphone	(revision 5512)
+++ pjproject/branches/projects/uwp/configure-iphone	(revision 5513)
@@ -19,5 +19,8 @@
   echo "             SDK."
   echo "  ARCH       Optional flags to specify target architecture, e.g."
-  echo "             ARCH='-arch armv6'. Default is armv7."
+  echo "             ARCH=\"-arch armv6\". Default is armv7."
+  echo "  MIN_IOS    Optional flags to specify minimum supported iOS"
+  echo "             versions, e.g. MIN_IOS=\"-miphoneos-version-min=10.0\". "
+  echo "             Default is 7.0."
   echo ""
   exit 0
@@ -116,4 +119,11 @@
 export ARCH_VAL=`echo ${ARCH} | sed 's/\-arch //' | sed -e 's/^[ \t]*//;s/[ \t]*$//' `
 
+if test "${MIN_IOS}" = ""; then
+  MIN_IOS="7.0"
+  echo "$F: MIN_IOS is not specified, choosing ${MIN_IOS}"
+  CFLAGS="${CFLAGS} -miphoneos-version-min=${MIN_IOS}"
+  LDFLAGS="${LDFLAGS} -miphoneos-version-min=${MIN_IOS}"
+fi
+
 # Set CXX if not set
 if test "${CXX}" = ""; then
Index: pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/cli_telnet.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/cli_telnet.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/cli_telnet.h	(revision 5513)
@@ -95,5 +95,5 @@
     /**
      * Specify a password to be asked to the end user to access the
-     * application.
+     * application. Currently this is not implemented yet.
      *
      * Default: empty (no password)
@@ -103,4 +103,5 @@
     /**
      * Specify text message to be displayed to newly connected users.
+     * Currently this is not implemented yet.
      *
      * Default: empty
Index: pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/dns.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/dns.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/dns.h	(revision 5513)
@@ -428,4 +428,20 @@
 
 /**
+ * Initialize DNS record as DNS AAAA record.
+ *
+ * @param rec		The DNS resource record to be initialized as DNS
+ *			AAAA record.
+ * @param res_name	Resource name.
+ * @param dnsclass	DNS class.
+ * @param ttl		Resource TTL value.
+ * @param ip_addr	Host address.
+ */
+PJ_DECL(void) pj_dns_init_aaaa_rr(pj_dns_parsed_rr *rec,
+				  const pj_str_t *res_name,
+				  unsigned dnsclass,
+				  unsigned ttl,
+				  const pj_in6_addr *ip_addr);
+
+/**
  * Dump DNS packet to standard log.
  *
Index: pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/resolver.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/resolver.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/resolver.h	(revision 5513)
@@ -224,4 +224,45 @@
 
 } pj_dns_a_record;
+
+
+/**
+ * This structure represents DNS address record, i.e: DNS A and DNS AAAA
+ * records, as the result of parsing DNS response packet using
+ * #pj_dns_parse_addr_response().
+ */
+typedef struct pj_dns_addr_record
+{
+    /** The target name being queried.   */
+    pj_str_t		name;
+
+    /** If target name corresponds to a CNAME entry, the alias contains
+     *  the value of the CNAME entry, otherwise it will be empty.
+     */
+    pj_str_t		alias;
+
+    /** Number of IP addresses. */
+    unsigned		addr_count;
+
+    /** IP addresses of the host found in the response */
+    struct {
+
+	/** IP address family */
+	int		af;
+	
+	/** IP address */
+	union {
+	    /** IPv4 address */
+	    pj_in_addr	v4;
+
+	    /** IPv6 address */
+	    pj_in6_addr	v6;
+	} ip;
+
+    } addr[PJ_DNS_MAX_IP_IN_A_REC];
+
+    /** Internal buffer for hostname and alias. */
+    char		buf_[128];
+
+} pj_dns_addr_record;
 
 
@@ -409,4 +450,19 @@
 
 /**
+ * A utility function to parse a DNS response containing AAAA records into 
+ * DNS AAAA record.
+ *
+ * @param pkt	    The DNS response packet.
+ * @param rec	    The structure to be initialized with the parsed
+ *		    DNS AAAA record from the packet.
+ *
+ * @return	    PJ_SUCCESS if response can be parsed successfully.
+ */
+PJ_DECL(pj_status_t) pj_dns_parse_addr_response(
+					    const pj_dns_parsed_packet *pkt,
+					    pj_dns_addr_record *rec);
+
+
+/**
  * Put the specified DNS packet into DNS cache. This function is mainly used
  * for testing the resolver, however it can also be used to inject entries
Index: pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/srv_resolver.h
===================================================================
--- pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/srv_resolver.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjlib-util/include/pjlib-util/srv_resolver.h	(revision 5513)
@@ -85,6 +85,6 @@
      * resolution when the SRV resolution fails. This option may
      * be specified together with PJ_DNS_SRV_FALLBACK_AAAA to
-     * make the resolver fallback to AAAA if SRV resolution fails,
-     * and then to DNS A resolution if the AAAA resolution fails.
+     * make the resolver fallback to both DNS A and DNS AAAA
+     * resolutions if SRV resolution fails.
      */
     PJ_DNS_SRV_FALLBACK_A	= 1,
@@ -93,7 +93,7 @@
      * Specify if the resolver should fallback with DNS AAAA
      * resolution when the SRV resolution fails. This option may
-     * be specified together with PJ_DNS_SRV_FALLBACK_A to
-     * make the resolver fallback to AAAA if SRV resolution fails,
-     * and then to DNS A resolution if the AAAA resolution fails.
+     * be specified together with PJ_DNS_SRV_FALLBACK_AAAA to
+     * make the resolver fallback to both DNS A and DNS AAAA
+     * resolutions if SRV resolution fails.
      */
     PJ_DNS_SRV_FALLBACK_AAAA	= 2,
@@ -101,9 +101,16 @@
     /**
      * Specify if the resolver should try to resolve with DNS AAAA
-     * resolution first of each targets in the DNS SRV record. If
-     * this option is not specified, the SRV resolver will query
-     * the DNS A record for the target instead.
-     */
-    PJ_DNS_SRV_RESOLVE_AAAA	= 4
+     * resolution of each targets in the DNS SRV record. If this
+     * option is not specified, the SRV resolver will query the
+     * DNS A record for the target instead.
+     */
+    PJ_DNS_SRV_RESOLVE_AAAA	= 4,
+
+    /**
+     * Specify if the resolver should try to resolve with DNS AAAA
+     * resolution only (i.e: without DNS A resolution) for each targets
+     * in the DNS SRV record.
+     */
+    PJ_DNS_SRV_RESOLVE_AAAA_ONLY = 8
 
 } pj_dns_srv_option;
@@ -132,5 +139,5 @@
 
 	/** The host address. */
-	pj_dns_a_record		server;
+	pj_dns_addr_record	server;
 
     } entry[PJ_DNS_SRV_MAX_ADDR];
